diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index 5ada4a739..92c7ab6e3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -4,18 +4,18 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockFire;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicFire;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelFire<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T> {
     private final boolean overrideRender;
-    public BlockModelFire(Block block) {
+    public BlockModelFire(Block<T> block) {
         this(block, false);
     }
 
-    public BlockModelFire(Block block, boolean overrideRender) {
+    public BlockModelFire(Block<T> block, boolean overrideRender) {
         super(block);
         this.overrideRender = overrideRender;
     }
@@ -39,7 +39,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T> {
         double vMin = tex.getIconVMin();
         double vMax = tex.getIconVMax();
         final float yOffset = 1.4F;
-        if(overrideRender || renderBlocks.blockAccess.isBlockNormalCube(x, y - 1, z) || ((BlockFire)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x, y - 1, z))
+        if(overrideRender || renderBlocks.blockAccess.isBlockNormalCube(x, y - 1, z) || BlockLogicFire.canBurn(renderBlocks.blockAccess, x, y - 1, z))
         {
             double d8 = (double)x + 0.5D + 0.2D;
             double d9 = ((double)x + 0.5D) - 0.2D;
@@ -114,7 +114,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T> {
                 uMax = uMin;
                 uMin = d10;
             }
-            if(((BlockFire)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x - 1, y, z))
+            if(BlockLogicFire.canBurn(renderBlocks.blockAccess, x - 1, y, z))
             {
                 tessellator.addVertexWithUV((float)x + f3, (float)y + yOffset + f4, z + 1, uMax, vMin);
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z + 1, uMax, vMax);
@@ -125,7 +125,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T> {
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z + 1, uMax, vMax);
                 tessellator.addVertexWithUV((float)x + f3, (float)y + yOffset + f4, z + 1, uMax, vMin);
             }
-            if(((BlockFire)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x + 1, y, z))
+            if(BlockLogicFire.canBurn(renderBlocks.blockAccess, x + 1, y, z))
             {
                 tessellator.addVertexWithUV((float)(x + 1) - f3, (float)y + yOffset + f4, z, uMin, vMin);
                 tessellator.addVertexWithUV((x + 1), (float)(y) + f4, z, uMin, vMax);
@@ -136,7 +136,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T> {
                 tessellator.addVertexWithUV((x + 1), (float)(y) + f4, z, uMin, vMax);
                 tessellator.addVertexWithUV((float)(x + 1) - f3, (float)y + yOffset + f4, z, uMin, vMin);
             }
-            if(((BlockFire)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x, y, z - 1))
+            if(BlockLogicFire.canBurn(renderBlocks.blockAccess, x, y, z - 1))
             {
                 tessellator.addVertexWithUV(x, (float)y + yOffset + f4, (float)z + f3, uMax, vMin);
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z, uMax, vMax);
@@ -147,7 +147,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T> {
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z, uMax, vMax);
                 tessellator.addVertexWithUV(x, (float)y + yOffset + f4, (float)z + f3, uMax, vMin);
             }
-            if(((BlockFire)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x, y, z + 1))
+            if(BlockLogicFire.canBurn(renderBlocks.blockAccess, x, y, z + 1))
             {
                 tessellator.addVertexWithUV(x + 1, (float)y + yOffset + f4, (float)(z + 1) - f3, uMin, vMin);
                 tessellator.addVertexWithUV(x + 1, (float)(y) + f4, (z + 1), uMin, vMax);
@@ -158,7 +158,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T> {
                 tessellator.addVertexWithUV(x + 1, (float)(y) + f4, (z + 1), uMin, vMax);
                 tessellator.addVertexWithUV(x + 1, (float)y + yOffset + f4, (float)(z + 1) - f3, uMin, vMin);
             }
-            if(((BlockFire)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x, y + 1, z))
+            if(BlockLogicFire.canBurn(renderBlocks.blockAccess, x, y + 1, z))
             {
                 double d11 = (double)x + 0.5D + 0.5D;
                 double d13 = ((double)x + 0.5D) - 0.5D;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java
index 41b48e2f2..2c600d299 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java
@@ -3,13 +3,13 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFlowerStackable;
+import net.minecraft.core.block.BlockLogicFlowerStackable;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelFlowerStackable<T extends BlockFlowerStackable> extends BlockModelCrossedSquares<T> {
+public class BlockModelFlowerStackable<T extends BlockLogicFlowerStackable> extends BlockModelCrossedSquares<T> {
     private final IconCoordinate[] ICONS;
 
-    public BlockModelFlowerStackable(Block block, String baseTexture) {
+    public BlockModelFlowerStackable(Block<T> block, String baseTexture) {
         super(block);
 
         ICONS = new IconCoordinate[T.MAX_STACK_COUNT + 1];
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 74be6157c..783fe0b99 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -5,15 +5,16 @@ import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelFluid(Block block) {
+public class BlockModelFluid<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelFluid(Block<T> block) {
         super(block);
     }
 
@@ -45,17 +46,17 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
         final float sideEastWest = 0.6f;
 
         final float yOff = 0.001f;
-        Material material = block.blockMaterial;
+        Material material = block.getMaterial();
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        float f7 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x, y, z, material);
-        float f8 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x, y, z + 1, material);
-        float f9 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z + 1, material);
-        float f10 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z, material);
+        float f7 = BlockLogicFluid.getFluidHeight(renderBlocks.blockAccess, x, y, z, material);
+        float f8 = BlockLogicFluid.getFluidHeight(renderBlocks.blockAccess, x, y, z + 1, material);
+        float f9 = BlockLogicFluid.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z + 1, material);
+        float f10 = BlockLogicFluid.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z, material);
         if(renderBlocks.renderAllFaces || renderTop)
         {
             didRender = true;
             IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.TOP, meta);
-            float rotation = (float) BlockFluid.getSlopeAngle(renderBlocks.blockAccess, x, y, z, material);
+            float rotation = (float) BlockLogicFluid.getSlopeAngle(renderBlocks.blockAccess, x, y, z, material);
             if(rotation > -999F)
             {
                 texture = getBlockTextureFromSideAndMetadata(Side.NORTH, meta);
@@ -218,7 +219,7 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
     public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
         Material material = blockAccess.getBlockMaterial(x, y, z);
-        if(material == block.blockMaterial)
+        if(material == block.getMaterial())
         {
             return false;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
index 50be90892..e47a6c138 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
@@ -3,20 +3,21 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFullyRotatable;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicFullyRotatable;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockModelFullyRotatable<T extends BlockFullyRotatable> extends BlockModelStandard<T> {
-    public BlockModelFullyRotatable(Block block) {
+public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelFullyRotatable(Block<T> block) {
         super(block);
     }
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        final Direction dir = BlockFullyRotatable.metaToDirection(meta);
+        final Direction dir = BlockLogicFullyRotatable.metaToDirection(meta);
 
         switch (dir) {
             case DOWN:
@@ -58,6 +59,7 @@ public class BlockModelFullyRotatable<T extends BlockFullyRotatable> extends Blo
         return result;
     }
 
+
     @Override
     public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         super.renderBlockOnInventory(tessellator, 1, brightness, alpha, lightmapCoordinate);
@@ -65,10 +67,10 @@ public class BlockModelFullyRotatable<T extends BlockFullyRotatable> extends Blo
 
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
-        final Direction dir = BlockFullyRotatable.metaToDirection(data);
+        final Direction dir = BlockLogicFullyRotatable.metaToDirection(data);
         if (side == dir.getSide()) {
             return atlasIndices[Side.TOP.getId()];
         }
         return side.getDirection() != dir.getOpposite() ? atlasIndices[Side.NORTH.getId()] : atlasIndices[Side.BOTTOM.getId()];
     }
-}
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
index bbb864709..d512b8726 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
@@ -3,15 +3,16 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelFurnace<T extends Block>
+public class BlockModelFurnace<T extends BlockLogic>
     extends BlockModelHorizontalRotation<T> {
 
-    public BlockModelFurnace(Block block) {
+    public BlockModelFurnace(Block<T> block) {
         super(block);
     }
 
@@ -26,8 +27,7 @@ public class BlockModelFurnace<T extends Block>
             if (container != null) {
                 boolean hasOutput = container.getItem(2) != null;
                 if (hasOutput) {
-                    IconCoordinate newFront = TextureRegistry.getTexture(originalFront.namespaceId.namespace + ":block/" + originalFront.namespaceId.value + "_filled");
-                    return newFront;
+                    return TextureRegistry.getTexture(originalFront.namespaceId.namespace + ":block/" + originalFront.namespaceId.value + "_filled");
                 }
             }
             return originalFront;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
index efb4fe85d..862c7b768 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
@@ -14,7 +15,7 @@ import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelGrass<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T> {
     public static boolean useOverlay = false;
     private static final IconCoordinate[] overlayIndices = new IconCoordinate[]{
             null,
@@ -24,7 +25,7 @@ public class BlockModelGrass<T extends Block> extends BlockModelStandard<T> {
             TextureRegistry.getTexture("minecraft:block/grass/side_overlay"),
             TextureRegistry.getTexture("minecraft:block/grass/side_overlay")};
     protected IconCoordinate snowSide = TextureRegistry.getTexture("minecraft:block/grass/snowy_side");
-    public BlockModelGrass(Block block) {
+    public BlockModelGrass(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
index faaf02d26..fe338966d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
@@ -2,19 +2,20 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRotatable;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicRotatable;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 
-public class BlockModelHorizontalRotation<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelHorizontalRotation(Block block) {
+public class BlockModelHorizontalRotation<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelHorizontalRotation(Block<T> block) {
         super(block);
     }
 
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        int index = Sides.orientationLookUpHorizontal[6 * Math.min(data & BlockRotatable.MASK_DIRECTION, 5) + side.getId()];
+        int index = Sides.orientationLookUpHorizontal[6 * Math.min(data & BlockLogicRotatable.MASK_DIRECTION, 5) + side.getId()];
         if (index >= Sides.orientationLookUpHorizontal.length) return atlasIndices[0];
         return atlasIndices[index];
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java
index 4f39d4fc9..0c6221b2e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java
@@ -1,11 +1,12 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelIce<T extends Block> extends BlockModelTransparent<T> {
-    public BlockModelIce(Block block) {
+public class BlockModelIce<T extends BlockLogic> extends BlockModelTransparent<T> {
+    public BlockModelIce(Block<T> block) {
         super(block, false);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
index ad05a9539..e644dd943 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
@@ -5,12 +5,13 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelJar<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelJar<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate jarEmpty = TextureRegistry.getTexture("minecraft:block/jar");
     protected IconCoordinate jarFull = TextureRegistry.getTexture("minecraft:block/jar_dirt");
-    public BlockModelJar(Block block) {
+    public BlockModelJar(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
index 677785f41..eeb5ea75f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
@@ -4,10 +4,11 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelLadder<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelLadder(Block block) {
+public class BlockModelLadder<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelLadder(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLamp.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLamp.java
index c4fde0924..44b125a73 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLamp.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLamp.java
@@ -3,12 +3,12 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLamp;
+import net.minecraft.core.block.BlockLogicLamp;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelLamp<T extends BlockLamp> extends BlockModelStandard<T> {
+public class BlockModelLamp<T extends BlockLogicLamp> extends BlockModelStandard<T> {
     private static final IconCoordinate[] texCoordsInactive = new IconCoordinate[DyeColor.COLOR_AMOUNT];
     private static final IconCoordinate[] texCoordsActive = new IconCoordinate[DyeColor.COLOR_AMOUNT];
 
@@ -19,7 +19,7 @@ public class BlockModelLamp<T extends BlockLamp> extends BlockModelStandard<T> {
         }
     }
 
-    public BlockModelLamp(Block block) {
+    public BlockModelLamp(Block<T> block) {
         super(block);
     }
 
@@ -27,7 +27,7 @@ public class BlockModelLamp<T extends BlockLamp> extends BlockModelStandard<T> {
     public IconCoordinate getBlockTexture(WorldSource worldSource, int x, int y, int z, Side side)
     {
         int color = worldSource.getBlockMetadata(x, y, z) & DyeColor.MASK_COLOR;
-        if (block.isActive) {
+        if (block.getLogic().isActive) {
             return texCoordsActive[color];
         } else {
             return texCoordsInactive[color];
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
index f3cc255b0..ea2ba175e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
@@ -4,19 +4,20 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLanternFirefly;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicLanternFirefly;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelLantern<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelLantern(Block block) {
+public class BlockModelLantern<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelLantern(Block<T> block) {
         super(block);
     }
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        boolean isHanging = (meta & BlockLanternFirefly.MASK_HANGING) == 0;
-        boolean isAngled = (meta & BlockLanternFirefly.MASK_ANGLED) != 0;
+        boolean isHanging = (meta & BlockLogicLanternFirefly.MASK_HANGING) == 0;
+//        boolean isAngled = (meta & BlockLogicLanternFirefly.MASK_ANGLED) != 0;
 
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
index c19c8b090..eb749ae44 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
@@ -2,13 +2,14 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelLayer<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelLayer(Block block) {
+public class BlockModelLayer<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelLayer(Block<T> block) {
         super(block);
         withCustomItemBounds(0.0f, 0.0f, 0.0f, 1.0f, 2 / 16F, 1.0f);
     }
@@ -21,7 +22,7 @@ public class BlockModelLayer<T extends Block> extends BlockModelStandard<T> {
     @Override
     public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side, int meta)
     {
-        if(side > 1 && blockAccess.getBlockId(x, y, z) == block.id && blockAccess.getBlockMetadata(x, y, z) == meta){
+        if(side > 1 && blockAccess.getBlockId(x, y, z) == block.id() && blockAccess.getBlockMetadata(x, y, z) == meta){
             return false;
         }
         return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index cdbedc79d..f5f5a7ed9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -3,15 +3,16 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelLeaves<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T> {
     protected static boolean fancyGraphics;
     protected final IconCoordinate fancyLeavesTexture;
 
-    public BlockModelLeaves(Block block, String leavesTex) {
+    public BlockModelLeaves(Block<T> block, String leavesTex) {
         super(block);
         withTextures(leavesTex);
         fancyLeavesTexture = TextureRegistry.getTexture(leavesTex + "_fancy");
@@ -30,7 +31,7 @@ public class BlockModelLeaves<T extends Block> extends BlockModelStandard<T> {
     public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
         int i1 = blockAccess.getBlockId(x, y, z);
-        if(!fancyGraphics && i1 == block.id)
+        if(!fancyGraphics && i1 == block.id())
         {
             return false;
         } else
